<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Entity\LetterTemplateEntity;
use RxConnexionBundle\Entity\PatientLetterEntity;
use RxConnexionBundle\Form\LetterTemplateForm;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Entity\DeviceEntity;

use RxConnexionBundle\Form\DeviceForm;

/**
 * @Route("/main/letter_template")
 */
class LetterTemplateController extends Controller
{
    /**
     * @Route("", name="letter_template")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Letter Template'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/LetterTemplate/index.html.twig', array(
            'title' => 'Manage Letter Template',
            'page_title' => 'Manage Letter Template',
            'javascripts' => array('rxconnexion/admin/js/letterTemplate/letterTemplate.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="letter_template_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Letter Template Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:LetterTemplateEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('letter_template_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['letterType'],
//                    $row['letterType_description'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "letter_template_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Letter Template New', 'Admin Letter Template Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $letterTemplate = $em->getRepository('RxConnexionBundle:LetterTemplateEntity')->find(base64_decode($id));
        if(!$letterTemplate) {
            $letterTemplate = new LetterTemplateEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(LetterTemplateForm::class, $letterTemplate, $formOptions);

        if($request->getMethod() === 'POST') {

            $letterTemplate_form = $request->get($form->getName());
            $result = $this->processForm($letterTemplate_form, $letterTemplate, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('letter_template'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('letter_template_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('letter_template_form'), 302);
                }
            } else {
                $form->submit($letterTemplate_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Letter Template';

        return $this->render('@RxConnexion/LetterTemplate/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/letterTemplate/letterTemplate_form.js?v=1.0.1'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($letter_template_form, $letter_template, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:LetterTemplateEntity')->validate($letter_template_form);

        if(!count($errors)) {

            switch($letter_template_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($letter_template);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Letter Template',
                            $em->getClassMetadata(LetterTemplateEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $letter_template;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Letter Template',
                        $em->getClassMetadata(LetterTemplateEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $letter_template;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Letter Template',
                        $em->getClassMetadata(LetterTemplateEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $letter_template;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($device);
                        $letter_template->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route(
     *      "/letter_template_data/{letter_type}",
     *      defaults = {
     *          "letter_type": null,
     *      },
     *      name = "letter_template_data"
     * )
     */
    public function letterTemplateData(Request $request, $letter_type) {

        $em = $this->getDoctrine()->getManager();
        $letterTemplateData = $em->getRepository('RxConnexionBundle:LetterTemplateEntity')->findOneBy(array(
            'letterType' => urldecode($letter_type),
            'isDeleted' => 0
        ));
        $letterTemplateDataArray = array();
        if ($letterTemplateData && $letterTemplateData != null) {
            $letterTemplateDataArray = array(
                'fax_cover_body' => $letterTemplateData->getFaxCoverBody(),
                'body' => $letterTemplateData->getBody()
            );
        } else {
            $letterTemplateDataArray = array(
                'fax_cover_body' => '',
                'body' => ''
            );
        }


        return new JsonResponse($letterTemplateDataArray);
    }
}
